package com.unis.ynls.dataDictionary.config;

import com.unis.ynls.dataDictionary.service.DataDictionaryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * @Description: 服务启动后执行相关的动作
 * @author: 杨祖榕
 * @Date: 2018-11-22 18:29
 * @Version v1.0
 **/
@Component
@Order(1)
public class MyApplicationRunner implements ApplicationRunner {

    @Autowired
    private DataDictionaryService dataDictionaryService;

    @Override
    public void run(ApplicationArguments applicationArguments) {
        System.out.println("-------------->" + "数据字典服务启动，now = " + new Date());
        System.out.println("-------------->" + "将数据字典存放 Redis开始");

        long startTime = System.currentTimeMillis();
//        dataDictionaryService.clearRedisDataDictionary();//清空Redis中的数据字典
        dataDictionaryService.dataDictionarys2Redis();
        long endTime = System.currentTimeMillis();
        long timeSeconds = (endTime - startTime) / 1000;//秒
        String timeStr = timeSeconds / 60 + "分" + timeSeconds % 60 + "秒";
        System.out.println("-------------->" + "将数据字典存放 Redis结束，用时：" + timeStr);
    }


}
