package com.unis.ynls.dataDictionary.controller;

import com.alibaba.fastjson.JSONObject;
import com.unis.ynls.dataDictionary.constant.RedisKey;
import com.unis.ynls.dataDictionary.service.SysOrgRelateService;
import com.unis.ynls.dataDictionary.utils.ResponseWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author by PIG
 * 2023/11/1 16
 */
@Api(value = "redis数据同步", tags = {"redis"})
@RestController
@RequestMapping("/redis")
@Log4j2
public class RedisInitController {

    @Autowired
    SysOrgRelateService sysOrgRelateService;

    @ApiOperation(value = "刷新组织关系 ", notes = RedisKey.ORG_RELATE)
    @PutMapping(value = "/refresh")
    public ResponseWrapper findById(@RequestBody JSONObject params) {
        sysOrgRelateService.refreshRedis(params);
        return ResponseWrapper.success();
    }
}
