package com.unis.ynls.dataDictionary.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.unis.ynls.dataDictionary.constant.RedisDataBaseIndex;
import com.unis.ynls.dataDictionary.constant.RedisKey;
import com.unis.ynls.dataDictionary.entity.SysOrgRelateEntity;
import com.unis.ynls.dataDictionary.mapper.SysOrgRelateMapper;
import com.unis.ynls.dataDictionary.service.SysOrgRelateService;
import com.unis.ynls.dataDictionary.utils.RedisUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.ValueOperations;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * @author by PIG
 * 2023/11/1 17
 */
@Service
public class SysOrgRelateServiceImpl implements SysOrgRelateService {

    @Autowired
    SysOrgRelateMapper sysOrgRelateMapper;

    @Autowired
    RedisUtil redisUtil;

    @Override
    public int refreshRedis(JSONObject params) {
        String redisKey = params.getString("key");
        SysOrgRelateEntity queryEntity = new SysOrgRelateEntity();
        redisUtil.changeData(RedisDataBaseIndex.DB2);
        List<SysOrgRelateEntity> list = sysOrgRelateMapper.select(queryEntity);
        Map<String, List<SysOrgRelateEntity>> collect = list.stream()
                .filter(i -> i.getOrgCode() != null && i.getRelateOrg()!= null)
                .collect(Collectors.groupingBy(SysOrgRelateEntity::getOrgCode));
        for (Map.Entry<String, List<SysOrgRelateEntity>> entry : collect.entrySet()) {
            String key = entry.getKey();
            List<SysOrgRelateEntity> value = entry.getValue();
            List<String> relateOrg = value.stream().map(SysOrgRelateEntity::getRelateOrg).collect(Collectors.toList());
            JSONObject data = new JSONObject();
            if (relateOrg.size() == 1) {
                if (relateOrg.get(0).equals("看所有")) {
                    data.put("type", "all");
                    data.put("orgList", new ArrayList<>());
                }else {
                    data.put("type", "part");
                    data.put("orgList", relateOrg);
                }
            }else {
                data.put("type", "part");
                data.put("orgList", relateOrg);
            }
            redisUtil.setCacheObject(RedisKey.ORG_RELATE + key, data);
        }
        return list.size();
    }
}
