package com.unis.ynls.dataDictionary.utils.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import java.util.Date;
import java.util.List;

/**
 * 用户信息 表现层对象
 *
 * @author 杨祖榕
 * @since 2019-01-07 14:04:57
 */
@Getter
@Setter
@ToString
@ApiModel(description = "用户信息",value = "用户信息")
public class UserInfoVO {

    @ApiModelProperty(value = "主键")
    private String id;

    @ApiModelProperty(value = "业务种类，1：粮食业务，2：XX业务...")
    private String bizType;

    @ApiModelProperty(value = "用户帐号")
    private String userAccount;

    @ApiModelProperty(value = "用户姓名")
    private String userName;

    @ApiModelProperty(value = "用户姓名拼音")
    private String pyName;

    @ApiModelProperty(value = "密码")
    private String userPasswd;

    @ApiModelProperty(value = "密码盐值")
    private String pwSalt;

    @ApiModelProperty(value = "曾用名")
    private String beforeName;

    @ApiModelProperty(value = "操作级别，10：非密，20：秘密，30：机密，50：绝密")
    private Integer opType;

    @ApiModelProperty(value = "1：粮食局，2：企业用户, 20：粮科院，25：检验单位,75：外部单位")
    private String userType;

    @ApiModelProperty(value = "-1：非管理员，1：管理员")
    private Integer admType;

    @ApiModelProperty(value = "10：系统管理员(三员)，20：安全保密员(三员)，30：安全审计员(三员)")
    private Integer admType2;

    @ApiModelProperty(value = "职务名称")
    private String jobTitle;

    @ApiModelProperty(value = "职务级别")
    private String jobLevel;

    @ApiModelProperty(value = "用户头像")
    private String userPhoto;

    @ApiModelProperty(value = "出生日期")
    private Date userBirthday;

    @ApiModelProperty(value = "性别，1：男，2：女")
    private Integer userGender;

    @ApiModelProperty(value = "学历")
    private String userEducation;

    @ApiModelProperty(value = "手机号")
    private String userMobile;

    @ApiModelProperty(value = "家庭电话")
    private String homeTelephone;

    @ApiModelProperty(value = "办公电话")
    private String officeTelephone;

    @ApiModelProperty(value = "传真")
    private String userFax;

    @ApiModelProperty(value = "用户QQ")
    private String userQQ;

    @ApiModelProperty(value = "电子邮箱")
    private String email;

    @ApiModelProperty(value = "国籍")
    private String userNation;

    @ApiModelProperty(value = "省")
    private String userProvince;

    @ApiModelProperty(value = "市")
    private String userCity;

    @ApiModelProperty(value = "县")
    private String userCounty;

    @ApiModelProperty(value = "详细地址")
    private String userAddr;

    @ApiModelProperty(value = "邮政编码")
    private String postCode;

    @ApiModelProperty(value = "是否锁定 ，1：锁定，0：非锁定")
    private Integer isLocked;

    @ApiModelProperty(value = "身份证号")
    private String idNum;

    @ApiModelProperty(value = "用户所属单位机构编码")
    private String orgCode;

    @ApiModelProperty(value = "用户所属部门机构编码")
    private String deptCode;

    @ApiModelProperty(value = "单位ID")
    private String orgId;

    @ApiModelProperty(value = "单位名称")
    private String orgName;

    @ApiModelProperty(value = "部门ID")
    private String deptId;

    @ApiModelProperty(value = "部门名称")
    private String deptName;

    @ApiModelProperty(value = "角色情况")
    private String roleInfo;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "角色ID")
    private List<String> roleIds;

    @ApiModelProperty(value = "角色名称")
    private List<String> roleNames;

    @ApiModelProperty(value = "行政区划")
    private String areaCode;

    // @TODO 后期修改
    @ApiModelProperty(value = "所属省份")
    private String provinceCode = "530000";

}